"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireDefault(require("react"));

var _reactRouterDom = require("react-router-dom");

var _scrollBehavior = _interopRequireDefault(require("scroll-behavior"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _StateStorage = _interopRequireDefault(require("./StateStorage"));

const propTypes = {
  shouldUpdateScroll: _propTypes.default.func,
  children: _propTypes.default.element.isRequired,
  location: _propTypes.default.object.isRequired,
  history: _propTypes.default.object.isRequired
};
const childContextTypes = {
  scrollBehavior: _propTypes.default.object.isRequired
};

class ScrollContext extends _react.default.Component {
  constructor(props, context) {
    super(props, context);
    (0, _defineProperty2.default)((0, _defineProperty2.default)((0, _defineProperty2.default)(this, "shouldUpdateScroll", (prevRouterProps, routerProps) => {
      const {
        shouldUpdateScroll
      } = this.props;

      if (!shouldUpdateScroll) {
        return true;
      } // Hack to allow accessing scrollBehavior._stateStorage.


      return shouldUpdateScroll.call(this.scrollBehavior, prevRouterProps, routerProps);
    }), "registerElement", (key, element, shouldUpdateScroll) => {
      this.scrollBehavior.registerElement(key, element, shouldUpdateScroll, this.getRouterProps());
    }), "unregisterElement", key => {
      this.scrollBehavior.unregisterElement(key);
    });
    const {
      history
    } = props;
    this.scrollBehavior = new _scrollBehavior.default({
      addTransitionHook: history.listen,
      stateStorage: new _StateStorage.default(),
      getCurrentLocation: () => this.props.location,
      shouldUpdateScroll: this.shouldUpdateScroll
    });
    this.scrollBehavior.updateScroll(null, this.getRouterProps());
  }

  getChildContext() {
    return {
      scrollBehavior: this
    };
  }

  componentDidUpdate(prevProps) {
    const {
      location,
      history
    } = this.props;
    const prevLocation = prevProps.location;

    if (location === prevLocation) {
      return;
    }

    const prevRouterProps = {
      history: prevProps.history,
      location: prevProps.location // The "scroll-behavior" package expects the "action" to be on the location
      // object so let's copy it over.

    };
    location.action = history.action;
    this.scrollBehavior.updateScroll(prevRouterProps, {
      history,
      location
    });
  }

  componentWillUnmount() {
    this.scrollBehavior.stop();
  }

  getRouterProps() {
    const {
      history,
      location
    } = this.props;
    return {
      history,
      location
    };
  }

  render() {
    return _react.default.Children.only(this.props.children);
  }

}

ScrollContext.propTypes = propTypes;
ScrollContext.childContextTypes = childContextTypes;

var _default = (0, _reactRouterDom.withRouter)(ScrollContext);

exports.default = _default;